# coding: utf-8

"""
    Apteco API

    An API to allow access to Apteco Marketing Suite resources  # noqa: E501

    The version of the OpenAPI document: v2
    Contact: support@apteco.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from apteco_api.configuration import Configuration


class Breakpoint(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'breakpoint': 'str',
        'x': 'int',
        'y': 'int',
        'size': 'Size',
        'notes_alignment': 'NotesAlignment'
    }

    attribute_map = {
        'breakpoint': 'breakpoint',
        'x': 'x',
        'y': 'y',
        'size': 'size',
        'notes_alignment': 'notesAlignment'
    }

    def __init__(self, breakpoint=None, x=None, y=None, size=None, notes_alignment=None, local_vars_configuration=None):  # noqa: E501
        """Breakpoint - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._breakpoint = None
        self._x = None
        self._y = None
        self._size = None
        self._notes_alignment = None
        self.discriminator = None

        self.breakpoint = breakpoint
        self.x = x
        self.y = y
        self.size = size
        self.notes_alignment = notes_alignment

    @property
    def breakpoint(self):
        """Gets the breakpoint of this Breakpoint.  # noqa: E501

        The target breakpoint size  # noqa: E501

        :return: The breakpoint of this Breakpoint.  # noqa: E501
        :rtype: str
        """
        return self._breakpoint

    @breakpoint.setter
    def breakpoint(self, breakpoint):
        """Sets the breakpoint of this Breakpoint.

        The target breakpoint size  # noqa: E501

        :param breakpoint: The breakpoint of this Breakpoint.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and breakpoint is None:  # noqa: E501
            raise ValueError("Invalid value for `breakpoint`, must not be `None`")  # noqa: E501
        allowed_values = ["xs", "sm", "md", "lg", "xl"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and breakpoint not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `breakpoint` ({0}), must be one of {1}"  # noqa: E501
                .format(breakpoint, allowed_values)
            )

        self._breakpoint = breakpoint

    @property
    def x(self):
        """Gets the x of this Breakpoint.  # noqa: E501

        The target breakpoint x location  # noqa: E501

        :return: The x of this Breakpoint.  # noqa: E501
        :rtype: int
        """
        return self._x

    @x.setter
    def x(self, x):
        """Sets the x of this Breakpoint.

        The target breakpoint x location  # noqa: E501

        :param x: The x of this Breakpoint.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and x is None:  # noqa: E501
            raise ValueError("Invalid value for `x`, must not be `None`")  # noqa: E501

        self._x = x

    @property
    def y(self):
        """Gets the y of this Breakpoint.  # noqa: E501

        The target breakpoint y location  # noqa: E501

        :return: The y of this Breakpoint.  # noqa: E501
        :rtype: int
        """
        return self._y

    @y.setter
    def y(self, y):
        """Sets the y of this Breakpoint.

        The target breakpoint y location  # noqa: E501

        :param y: The y of this Breakpoint.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and y is None:  # noqa: E501
            raise ValueError("Invalid value for `y`, must not be `None`")  # noqa: E501

        self._y = y

    @property
    def size(self):
        """Gets the size of this Breakpoint.  # noqa: E501


        :return: The size of this Breakpoint.  # noqa: E501
        :rtype: Size
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this Breakpoint.


        :param size: The size of this Breakpoint.  # noqa: E501
        :type: Size
        """
        if self.local_vars_configuration.client_side_validation and size is None:  # noqa: E501
            raise ValueError("Invalid value for `size`, must not be `None`")  # noqa: E501

        self._size = size

    @property
    def notes_alignment(self):
        """Gets the notes_alignment of this Breakpoint.  # noqa: E501


        :return: The notes_alignment of this Breakpoint.  # noqa: E501
        :rtype: NotesAlignment
        """
        return self._notes_alignment

    @notes_alignment.setter
    def notes_alignment(self, notes_alignment):
        """Sets the notes_alignment of this Breakpoint.


        :param notes_alignment: The notes_alignment of this Breakpoint.  # noqa: E501
        :type: NotesAlignment
        """
        if self.local_vars_configuration.client_side_validation and notes_alignment is None:  # noqa: E501
            raise ValueError("Invalid value for `notes_alignment`, must not be `None`")  # noqa: E501

        self._notes_alignment = notes_alignment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Breakpoint):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Breakpoint):
            return True

        return self.to_dict() != other.to_dict()
