# coding: utf-8

"""
    Apteco API

    An API to allow access to Apteco Marketing Suite resources  # noqa: E501

    The version of the OpenAPI document: v2
    Contact: support@apteco.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from apteco_api.configuration import Configuration


class DashboardItemPreviewData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'dashboard_item_id': 'str',
        'drill_down_level': 'int',
        'sort_order': 'str',
        'base_query': 'Query',
        'data_specification': 'DashboardItemDataSpecification'
    }

    attribute_map = {
        'dashboard_item_id': 'dashboardItemId',
        'drill_down_level': 'drillDownLevel',
        'sort_order': 'sortOrder',
        'base_query': 'baseQuery',
        'data_specification': 'dataSpecification'
    }

    def __init__(self, dashboard_item_id=None, drill_down_level=None, sort_order=None, base_query=None, data_specification=None, local_vars_configuration=None):  # noqa: E501
        """DashboardItemPreviewData - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._dashboard_item_id = None
        self._drill_down_level = None
        self._sort_order = None
        self._base_query = None
        self._data_specification = None
        self.discriminator = None

        self.dashboard_item_id = dashboard_item_id
        self.drill_down_level = drill_down_level
        self.sort_order = sort_order
        self.base_query = base_query
        if data_specification is not None:
            self.data_specification = data_specification

    @property
    def dashboard_item_id(self):
        """Gets the dashboard_item_id of this DashboardItemPreviewData.  # noqa: E501

        The id for this dashboard item  # noqa: E501

        :return: The dashboard_item_id of this DashboardItemPreviewData.  # noqa: E501
        :rtype: str
        """
        return self._dashboard_item_id

    @dashboard_item_id.setter
    def dashboard_item_id(self, dashboard_item_id):
        """Sets the dashboard_item_id of this DashboardItemPreviewData.

        The id for this dashboard item  # noqa: E501

        :param dashboard_item_id: The dashboard_item_id of this DashboardItemPreviewData.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and dashboard_item_id is None:  # noqa: E501
            raise ValueError("Invalid value for `dashboard_item_id`, must not be `None`")  # noqa: E501

        self._dashboard_item_id = dashboard_item_id

    @property
    def drill_down_level(self):
        """Gets the drill_down_level of this DashboardItemPreviewData.  # noqa: E501

        The drill down level for this dashboard item  # noqa: E501

        :return: The drill_down_level of this DashboardItemPreviewData.  # noqa: E501
        :rtype: int
        """
        return self._drill_down_level

    @drill_down_level.setter
    def drill_down_level(self, drill_down_level):
        """Sets the drill_down_level of this DashboardItemPreviewData.

        The drill down level for this dashboard item  # noqa: E501

        :param drill_down_level: The drill_down_level of this DashboardItemPreviewData.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and drill_down_level is None:  # noqa: E501
            raise ValueError("Invalid value for `drill_down_level`, must not be `None`")  # noqa: E501

        self._drill_down_level = drill_down_level

    @property
    def sort_order(self):
        """Gets the sort_order of this DashboardItemPreviewData.  # noqa: E501

        Whether the chart for the given drill down level should be sorted in it's natural order, by ascending or descending values  # noqa: E501

        :return: The sort_order of this DashboardItemPreviewData.  # noqa: E501
        :rtype: str
        """
        return self._sort_order

    @sort_order.setter
    def sort_order(self, sort_order):
        """Sets the sort_order of this DashboardItemPreviewData.

        Whether the chart for the given drill down level should be sorted in it's natural order, by ascending or descending values  # noqa: E501

        :param sort_order: The sort_order of this DashboardItemPreviewData.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and sort_order is None:  # noqa: E501
            raise ValueError("Invalid value for `sort_order`, must not be `None`")  # noqa: E501
        allowed_values = ["Natural", "AscendingByValue", "DescendingByValue"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and sort_order not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `sort_order` ({0}), must be one of {1}"  # noqa: E501
                .format(sort_order, allowed_values)
            )

        self._sort_order = sort_order

    @property
    def base_query(self):
        """Gets the base_query of this DashboardItemPreviewData.  # noqa: E501


        :return: The base_query of this DashboardItemPreviewData.  # noqa: E501
        :rtype: Query
        """
        return self._base_query

    @base_query.setter
    def base_query(self, base_query):
        """Sets the base_query of this DashboardItemPreviewData.


        :param base_query: The base_query of this DashboardItemPreviewData.  # noqa: E501
        :type: Query
        """
        if self.local_vars_configuration.client_side_validation and base_query is None:  # noqa: E501
            raise ValueError("Invalid value for `base_query`, must not be `None`")  # noqa: E501

        self._base_query = base_query

    @property
    def data_specification(self):
        """Gets the data_specification of this DashboardItemPreviewData.  # noqa: E501


        :return: The data_specification of this DashboardItemPreviewData.  # noqa: E501
        :rtype: DashboardItemDataSpecification
        """
        return self._data_specification

    @data_specification.setter
    def data_specification(self, data_specification):
        """Sets the data_specification of this DashboardItemPreviewData.


        :param data_specification: The data_specification of this DashboardItemPreviewData.  # noqa: E501
        :type: DashboardItemDataSpecification
        """

        self._data_specification = data_specification

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DashboardItemPreviewData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DashboardItemPreviewData):
            return True

        return self.to_dict() != other.to_dict()
