# coding: utf-8

"""
    Apteco API

    An API to allow access to Apteco Marketing Suite resources  # noqa: E501

    The version of the OpenAPI document: v2
    Contact: support@apteco.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from apteco_api.configuration import Configuration


class OutputType(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'format': 'str',
        'export_extra_name': 'str'
    }

    attribute_map = {
        'name': 'name',
        'format': 'format',
        'export_extra_name': 'exportExtraName'
    }

    def __init__(self, name=None, format=None, export_extra_name=None, local_vars_configuration=None):  # noqa: E501
        """OutputType - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._format = None
        self._export_extra_name = None
        self.discriminator = None

        self.name = name
        if format is not None:
            self.format = format
        if export_extra_name is not None:
            self.export_extra_name = export_extra_name

    @property
    def name(self):
        """Gets the name of this OutputType.  # noqa: E501

        The name of the output type  # noqa: E501

        :return: The name of this OutputType.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this OutputType.

        The name of the output type  # noqa: E501

        :param name: The name of this OutputType.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def format(self):
        """Gets the format of this OutputType.  # noqa: E501

        The format of the file to generate  # noqa: E501

        :return: The format of this OutputType.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this OutputType.

        The format of the file to generate  # noqa: E501

        :param format: The format of this OutputType.  # noqa: E501
        :type: str
        """
        allowed_values = ["CSV", "SDF", "XLS", "XLSX", "MDB", "DBF", "URN", "NATIVEDUMP"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and format not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `format` ({0}), must be one of {1}"  # noqa: E501
                .format(format, allowed_values)
            )

        self._format = format

    @property
    def export_extra_name(self):
        """Gets the export_extra_name of this OutputType.  # noqa: E501

        The name of the Export Extras post-processing job to run on exported file  # noqa: E501

        :return: The export_extra_name of this OutputType.  # noqa: E501
        :rtype: str
        """
        return self._export_extra_name

    @export_extra_name.setter
    def export_extra_name(self, export_extra_name):
        """Sets the export_extra_name of this OutputType.

        The name of the Export Extras post-processing job to run on exported file  # noqa: E501

        :param export_extra_name: The export_extra_name of this OutputType.  # noqa: E501
        :type: str
        """

        self._export_extra_name = export_extra_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OutputType):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OutputType):
            return True

        return self.to_dict() != other.to_dict()
